# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict
from pydantic.v1 import BaseModel, Field, constr, validator

class ExternalFeeComponentFilter(BaseModel):
    """
    ExternalFeeComponentFilter
    """
    filter_id: constr(strict=True, max_length=16384, min_length=1) = Field(..., alias="filterId")
    filter: constr(strict=True, max_length=16384, min_length=1) = Field(...)
    applies_to: constr(strict=True, max_length=16384, min_length=1) = Field(..., alias="appliesTo")
    __properties = ["filterId", "filter", "appliesTo"]

    @validator('filter_id')
    def filter_id_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\s\S]*$", value):
            raise ValueError(r"must validate the regular expression /^[\s\S]*$/")
        return value

    @validator('filter')
    def filter_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\s\S]*$", value):
            raise ValueError(r"must validate the regular expression /^[\s\S]*$/")
        return value

    @validator('applies_to')
    def applies_to_validate_regular_expression(cls, value):
        """Validates the regular expression"""
        if not re.match(r"^[\s\S]*$", value):
            raise ValueError(r"must validate the regular expression /^[\s\S]*$/")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def __str__(self):
        """For `print` and `pprint`"""
        return pprint.pformat(self.dict(by_alias=False))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> ExternalFeeComponentFilter:
        """Create an instance of ExternalFeeComponentFilter from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> ExternalFeeComponentFilter:
        """Create an instance of ExternalFeeComponentFilter from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return ExternalFeeComponentFilter.parse_obj(obj)

        _obj = ExternalFeeComponentFilter.parse_obj({
            "filter_id": obj.get("filterId"),
            "filter": obj.get("filter"),
            "applies_to": obj.get("appliesTo")
        })
        return _obj
